=== debian/changelog ===
tensorpipe (0.0~git20200805.42033c5-3) unstable; urgency=medium

  * Fixup FTBFS due to incomplete not-installed file list.

 -- Mo Zhou <lumin@debian.org>  Mon, 19 Oct 2020 15:41:04 +0800

tensorpipe (0.0~git20200805.42033c5-2) unstable; urgency=medium

  * Change maintainer mail address into debian-ai@l.d.o
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 19 Oct 2020 13:09:41 +0800

tensorpipe (0.0~git20200805.42033c5-1) experimental; urgency=medium

  * Initial release. (Closes: #968426)

 -- Mo Zhou <lumin@debian.org>  Sun, 30 Aug 2020 19:39:49 +0800
