=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	-$(RM) -rfv third_party/googletest third_party/libuv
	ln -sfv /usr/src/googletest third_party/
	dh_auto_configure -- -DBUILD_SHARED_LIBS=ON -DTP_BUILD_TESTING=ON
