=== debian/changelog ===
tensorpipe (0.0~git20200928.95ff931-2) unstable; urgency=medium

  * Amend the list of headers -- one header was still missing.
  * Make libtensorpipe-dev depend on libnop-dev.

 -- Mo Zhou <lumin@debian.org>  Sat, 07 Nov 2020 17:05:50 +0800

tensorpipe (0.0~git20200928.95ff931-1) unstable; urgency=medium

  [ Adrian Bunk ]
  * Workaround FTBFS on armel/mipsel/m68k/powerpc/riscv64/sh4 (Closes: #972966)

  [ Mo Zhou ]
  * New upstream version 0.0~git20200928.95ff931 (PyTorch 1.7.0)
  * Remove two obsolete patches and refresh the remaining ones.
  * Add NEW B-D libnop-dev.
  * Refresh the list of headers to be installed.
  * Please pin to this upstream snapshot for PyTorch 1.7.0

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 12:34:08 +0800
