## tensorpipe 0.0~git20210304.369e855

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,19 +8,19 @@
   ${TP_STATIC_OR_SHARED}
   channel/error.cc
   channel/helpers.cc
-  channel/registry.cc
   common/address.cc
   common/error.cc
   common/fd.cc
   common/socket.cc
   common/system.cc
   core/context.cc
+  core/context_impl.cc
   core/error.cc
   core/listener.cc
+  core/listener_impl.cc
   core/pipe.cc
-  transport/connection.cc
-  transport/error.cc
-  transport/registry.cc)
+  core/pipe_impl.cc
+  transport/error.cc)
 
 # Support `#include <tensorpipe/foo.h>`.
 target_include_directories(tensorpipe PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>)
@@ -34,21 +34,27 @@
 ### basic
 
 target_sources(tensorpipe PRIVATE
-  channel/basic/channel.cc
-  channel/basic/context.cc)
+  channel/basic/channel_impl.cc
+  channel/basic/context.cc
+  channel/basic/context_impl.cc
+  channel/basic/factory.cc)
 
 ### xth
 
 target_sources(tensorpipe PRIVATE
-  channel/xth/channel.cc
-  channel/xth/context.cc)
+  channel/xth/channel_impl.cc
+  channel/xth/context.cc
+  channel/xth/context_impl.cc
+  channel/xth/factory.cc)
 
 ### cma
 
 if(TP_ENABLE_CMA)
   target_sources(tensorpipe PRIVATE
-    channel/cma/channel.cc
-    channel/cma/context.cc)
+    channel/cma/channel_impl.cc
+    channel/cma/context.cc
+    channel/cma/context_impl.cc
+    channel/cma/factory.cc)
   set(TENSORPIPE_HAS_CMA_CHANNEL 1)
 else()
   set(TENSORPIPE_HAS_CMA_CHANNEL 0)
@@ -57,8 +63,10 @@
 ### mpt
 
 target_sources(tensorpipe PRIVATE
-  channel/mpt/channel.cc
-  channel/mpt/context.cc)
+  channel/mpt/channel_impl.cc
+  channel/mpt/context.cc
+  channel/mpt/context_impl.cc
+  channel/mpt/factory.cc)
 
 ## CUDA channels
 
@@ -68,14 +76,41 @@
   target_include_directories(tensorpipe PUBLIC ${CUDA_INCLUDE_DIRS})
   set(TENSORPIPE_SUPPORTS_CUDA 1)
 
+  ### cuda_xth
+
+  target_sources(tensorpipe PRIVATE
+    channel/cuda_xth/channel_impl.cc
+    channel/cuda_xth/context.cc
+    channel/cuda_xth/context_impl.cc
+    channel/cuda_xth/factory.cc)
+
+  ### cuda_basic
+
+  target_sources(tensorpipe PRIVATE
+    channel/cuda_basic/channel_impl.cc
+    channel/cuda_basic/context.cc
+    channel/cuda_basic/context_impl.cc
+    channel/cuda_basic/factory.cc
+    common/cuda_loop.cc)
+
   ### cuda_ipc
 
   if(TP_ENABLE_CUDA_IPC)
     target_sources(tensorpipe PRIVATE
-      channel/cuda_ipc/channel.cc
-      channel/cuda_ipc/context.cc)
+      channel/cuda_ipc/channel_impl.cc
+      channel/cuda_ipc/context.cc
+      channel/cuda_ipc/context_impl.cc
+      channel/cuda_ipc/factory.cc)
     set(TENSORPIPE_HAS_CUDA_IPC_CHANNEL 1)
   endif()
+
+  target_sources(tensorpipe PRIVATE
+    common/ibv.cc
+    channel/cuda_gdr/channel_impl.cc
+    channel/cuda_gdr/context.cc
+    channel/cuda_gdr/context_impl.cc
+    channel/cuda_gdr/factory.cc)
+  set(TENSORPIPE_HAS_CUDA_GDR_CHANNEL 1)
 endif()
 
 ## Transports
@@ -83,13 +118,15 @@
 ### uv
 
 target_sources(tensorpipe PRIVATE
-  transport/uv/connection.cc
+  transport/uv/connection_impl.cc
   transport/uv/context.cc
+  transport/uv/context_impl.cc
   transport/uv/error.cc
-  transport/uv/listener.cc
+  transport/uv/factory.cc
+  transport/uv/listener_impl.cc
   transport/uv/loop.cc
   transport/uv/sockaddr.cc
-  transport/uv/uv.cc)
+  transport/uv/utility.cc)
 find_package(uv REQUIRED)
 target_link_libraries(tensorpipe PRIVATE uv::uv)
 
@@ -97,10 +134,12 @@
 
 if(TP_ENABLE_SHM)
   target_sources(tensorpipe PRIVATE
+    common/epoll_loop.cc
+    transport/shm/connection_impl.cc
     transport/shm/context.cc
-    transport/shm/connection.cc
-    transport/shm/listener.cc
-    transport/shm/loop.cc
+    transport/shm/context_impl.cc
+    transport/shm/factory.cc
+    transport/shm/listener_impl.cc
     transport/shm/reactor.cc
     transport/shm/sockaddr.cc
     util/ringbuffer/shm.cc
@@ -110,6 +149,23 @@
   set(TENSORPIPE_HAS_SHM_TRANSPORT 0)
 endif()
 
+### ibv
+
+if(TP_ENABLE_IBV)
+  target_sources(tensorpipe PRIVATE
+    common/epoll_loop.cc
+    common/ibv.cc
+    transport/ibv/connection_impl.cc
+    transport/ibv/context.cc
+    transport/ibv/context_impl.cc
+    transport/ibv/error.cc
+    transport/ibv/factory.cc
+    transport/ibv/listener_impl.cc
+    transport/ibv/reactor.cc
+    transport/ibv/sockaddr.cc
+    transport/ibv/utility.cc)
+  set(TENSORPIPE_HAS_IBV_TRANSPORT 1)
+endif()
 
 if(APPLE)
   find_library(CF CoreFoundation)
