=== test/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 add_executable(tensorpipe_test
   test.cc
+  test_environment.cc
   transport/context_test.cc
   transport/connection_test.cc
   transport/uv/uv_test.cc
@@ -26,8 +27,8 @@
 
 if(TP_ENABLE_SHM)
   target_sources(tensorpipe_test PRIVATE
+    common/epoll_loop_test.cc
     transport/shm/reactor_test.cc
-    transport/shm/loop_test.cc
     transport/shm/connection_test.cc
     transport/shm/sockaddr_test.cc
     transport/shm/shm_test.cc
@@ -37,10 +38,21 @@
     )
 endif()
 
+if(TP_ENABLE_IBV)
+  target_sources(tensorpipe_test PRIVATE
+    common/epoll_loop_test.cc
+    transport/ibv/connection_test.cc
+    transport/ibv/ibv_test.cc
+    transport/ibv/sockaddr_test.cc
+    util/ringbuffer/ringbuffer_test.cc
+    )
+endif()
+
 if(TP_ENABLE_CMA)
   target_sources(tensorpipe_test PRIVATE
     channel/cma/cma_test.cc
     )
+  add_subdirectory(channel/cma)
 endif()
 
 if(TP_USE_CUDA)
@@ -50,15 +62,26 @@
 
   target_sources(tensorpipe_test PRIVATE
     channel/channel_test_cuda.cc
+    channel/channel_test_cuda_multi_gpu.cc
+    common/cuda_test.cc
     )
 
   cuda_add_library(tensorpipe_cuda_kernel channel/kernel.cu)
   target_link_libraries(tensorpipe_test PRIVATE tensorpipe_cuda_kernel)
-endif()
 
-if(TP_ENABLE_CUDA_IPC)
   target_sources(tensorpipe_test PRIVATE
-    channel/cuda_ipc/cuda_ipc_test.cc
+    channel/cuda_xth/cuda_xth_test.cc
+    channel/cuda_basic/cuda_basic_test.cc
+    )
+
+  if(TP_ENABLE_CUDA_IPC)
+    target_sources(tensorpipe_test PRIVATE
+      channel/cuda_ipc/cuda_ipc_test.cc
+      )
+  endif()
+
+  target_sources(tensorpipe_test PRIVATE
+    channel/cuda_gdr/cuda_gdr_test.cc
     )
 endif()
 
@@ -69,4 +92,5 @@
 target_link_libraries(tensorpipe_test PRIVATE
   tensorpipe
   uv::uv
+  gmock
   gtest_main)
