=== debian/changelog ===
tensorpipe (0.0~git20210304.369e855-2.1) unstable; urgency=high

  * Non-maintainer upload.
  * debian/not-installed: Also exclude the following files from
    installation: (Closes: #997774)
    + usr/lib/*/cmake/GTest/GMockTargets-none.cmake
    + usr/lib/*/cmake/GTest/GMockTargets.cmake

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Dec 2021 15:09:03 -0500

tensorpipe (0.0~git20210304.369e855-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Sep 2021 02:19:19 +0000

tensorpipe (0.0~git20210304.369e855-1) experimental; urgency=medium

  * New upstream version 0.0~git20210304.369e855
    Please pin to this snapshot for PyTorch/v1.8.1
  * Refresh the list of header files to install.

 -- Mo Zhou <lumin@debian.org>  Wed, 19 May 2021 16:20:52 +0800
