=== debian/control ===
--- 
+++ 
@@ -14,12 +14,13 @@
                libuv1-dev,
                pkg-config,
                protobuf-compiler,
+               libnop-dev,
 Rules-Requires-Root: no
 
 Package: libtensorpipe-dev
 Section: libdevel
 Architecture: any
-Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}
+Depends: libtensorpipe0 (= ${binary:Version}), ${misc:Depends}, libnop-dev
 Description: tensor-aware point-to-point communication primitive for machine learning
  The TensorPipe project provides a tensor-aware channel to transfer rich
  objects from one process to another while using the fastest transport for the
