=== debian/changelog ===
tensorpipe (0.0~git20220513.bb1473a-5build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:03:39 +1100

tensorpipe (0.0~git20220513.bb1473a-5build1) noble; urgency=medium

  * No-change rebuild for libuv t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 16:54:04 +0100

tensorpipe (0.0~git20220513.bb1473a-5) unstable; urgency=medium

  * Upload to unstable.
  + Please pin to this snapshot for PyTorch/v2.0.X releases.

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Aug 2023 23:22:31 -0400

tensorpipe (0.0~git20220513.bb1473a-4) experimental; urgency=medium

  [ Debian Janitor ]
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.0, no changes needed.
  * Apply multi-arch hints. + libtensorpipe0: Add Multi-Arch: same.

  [ Mo Zhou ]
  * Add control files for the CUDA version of tensorpipe.
  * Add script cudabuild.sh to convert debian/ for cuda version.
  * Let the CPU/CUDA version Conflicts+Replaces each other.
  * Add SOVERSION for the CUDA version as well.
  * Only install the public headers (no longer install private headers).
  * cme update dpkg-copyright.

 -- Mo Zhou <lumin@debian.org>  Sat, 19 Aug 2023 23:22:07 -0400

tensorpipe (0.0~git20220513.bb1473a-3) unstable; urgency=medium

  * Add patch to fix GCC-12 FTBFS. (Closes: #1013051)

 -- Mo Zhou <lumin@debian.org>  Tue, 26 Jul 2022 08:58:23 -0700

tensorpipe (0.0~git20220513.bb1473a-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Jun 2022 10:01:02 -0700

tensorpipe (0.0~git20220513.bb1473a-1) experimental; urgency=medium

  * New upstream version 0.0~git20220513.bb1473a
    This snapshot should be fine with PyTorch/v1.12.X
  * Refresh existing patches.
  * Update installation control file.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 22:35:00 -0700
