=== debian/changelog ===
tensorpipe (0.0~git20250815.af0118d-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20250815.af0118d.
  * d/patches: fix FTBFS with GCC-15 (closes: #1097984).
  * d/control:
    + bump std-ver to 4.7.2 (no changes required).
    + replace obsolete B-D pkg-config -> pkgconf.
    + update description of binary packages.
  * d/upstream: add Repository field in metadata.
  * d/{control,rules}: build with ninja, skip running tests when building.

 -- Shengqi Chen <harry@debian.org>  Sat, 13 Sep 2025 17:59:49 +0800

tensorpipe (0.0~git20220513.bb1473a-6) unstable; urgency=medium

  * [CUDA] Manual rebuild.

 -- Mo Zhou <lumin@debian.org>  Thu, 05 Dec 2024 12:14:24 -0500
